/* Copyright 1995-96 Jon Griffiths.  See the file "jlib.doc" for details. */

/* target specific includes for LINUX_SVGALIB */

#ifndef __JTARGET_H__
#define __JTARGET_H__

#ifdef __cplusplus
extern "C" {
#endif 

#ifndef LINUX_SVGALIB
#error Wrong Target header file included in build.
#endif

#ifndef JLIB_MODE
#error Wrong Target header file included in build.
#endif


/* INPUT */
#include <vgamouse.h>
#include <vgakeyboard.h>

#define KEYBOARD_AVAILABLE 1    /* keyboard support is available */
#define MOUSE_AVAILABLE 1       /* mouse is available */ 
#define JOYSTICK_AVAILABLE 0    /* Uncomment if you want joystick support */

#if JOYSTICK_AVAILABLE == 1
#include <linux/joystick.h>
#endif

/* mouse */
#define MOUSE_NUM_BUTTONS 3
#define MOUSE_B_LEFT   MOUSE_LEFTBUTTON 
#define MOUSE_B_MIDDLE MOUSE_MIDDLEBUTTON 
#define MOUSE_B_RIGHT  MOUSE_RIGHTBUTTON 

#define BUTTON_DOWN(status)    (status)
#define BUTTON_CHECK(status,x) (status & (x))

#define UCLOCK_TICKS_PER_SECOND 1000000L

/* joystick */
typedef struct  {
    int joy,xcen,ycen,x1,y1,x2,y2,deadx1,deady1,deadx2,deady2;
} logical_joy;

extern logical_joy __jlib_joys[3];

#define JOY_FIRE1 1
#define JOY_FIRE2 2

#define FIRE_1_DOWN(status) (status & JOY_FIRE1)
#define FIRE_2_DOWN(status) (status & JOY_FIRE2)

/* SCREEN */
extern int __jlib_pages;   /* number of write pages in screen */

#ifdef SVGA_320x200x256
#define  SCREEN_WIDTH   320
#define  SCREEN_HEIGHT  200
#define  SCREEN_MAX_X   319
#define  SCREEN_MAX_Y   199
#endif
#ifdef SVGA_640x480x256
#define  SCREEN_WIDTH   640
#define  SCREEN_HEIGHT  480
#define  SCREEN_MAX_X   639
#define  SCREEN_MAX_Y   479
#endif
#ifdef SVGA_800x600x256
#define  SCREEN_WIDTH   800
#define  SCREEN_HEIGHT  600
#define  SCREEN_MAX_X   799
#define  SCREEN_MAX_Y   599
#endif

#define  SCREEN_NUM_COLORS 256
#define  SCREEN_NUM_PAGES 1

/* MEMORY OPERATIONS */
#include <string.h>

#define get_best_copy_method(s,d,l) ALIGNMENT_STATE_1

#define ALIGNMENT_STATE_1   0
#define ALIGNMENT_STATE_2   1
#define ALIGNMENT_STATE_3   2
#define ALIGNMENT_STATE_4   3
#define ALIGNMENT_STATE_5   4
#define ALIGNMENT_STATE_6   5
#define ALIGNMENT_STATE_7   6
#define ALIGNMENT_STATE_8   7

/* every memory copy is done using memcpy */
#define MEM_COPY_ALIGN_1(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_2(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_3(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_4(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_5(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_6(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_7(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_8(x,y,z)  memcpy( (y) , (x) , (z) )

#define FAST_SHORT_COPY(s,d,len)     memcpy( (d) , (s) , (len) )
#define FAST_LONG_COPY(s,d,len)      memcpy( (d) , (s) , (len) )
#define FAST_VERY_LONG_COPY(s,d,len) memcpy( (d) , (s) , (len) )
#define BYTE_COPY(s,d,len)           memcpy( (d) , (s) , (len) )
#define WORD_COPY(s,d,len)           memcpy( (d) , (s) , (len) )
#define LONG_COPY(s,d,len)           memcpy( (d) , (s) , (len) )

#ifdef __cplusplus
}
#endif 

#endif /* #ifndef __JTARGET_H__ */
